/*
	errchk1.c ver1.42
	1996/12/9
	by Kanaoka
*/
#include "parse.h"


void chkFiltree1(FILTREE *a)
{
	FILTREE *p;

	p = a;

	if(p->fil_id == fil_FUNC){
		if(p->s.func.dcl1 != NULL){
			chkDcltree1(p->s.func.dcl1);
		}
		if(p->s.func.dcl2 != NULL){
			chkDcltree1(p->s.func.dcl2);
		}
		if(p->s.func.dcl1 != NULL){
			chkDcltree1(p->s.func.dcl1);
		}
		if(p->s.func.stmt != NULL){
			chkStmt21(p->s.func.stmt);
		}
		if(p->next != NULL){
			chkFiltree1(p->next);
		}
	}
	if(p->fil_id == fil_DECL){
		if(p->s.dcl != NULL){
			chkDcltree1(p->s.dcl);
		}
		if(p->next != NULL){
			chkFiltree1(p->next);
		}
	}
}

void chkDcltree1(DCLTREE *a)
{
	DCLTREE *p;

	p = a;

	if(p->dcl_id == dcl_DCLON || p->dcl_id == dcl_MDCLON || p->dcl_id == dcl_PDCLON){
		if(p->s.dclon.dcl != NULL){
			chkDcltree1(p->s.dclon.dcl);
		}
		if(p->s.dclon.spc != NULL){
			chkSpctree1(p->s.dclon.spc);
		}
		if(p->next != NULL){
			chkDcltree1(p->next);
		}
	}
	if(p->dcl_id == dcl_DCLOR || p->dcl_id == dcl_MDCLOR || p->dcl_id == dcl_EDCLOR){
		if(p->s.dclor.dcl != NULL){
			chkDcltree1(p->s.dclor.dcl);
		}
		if(p->s.dclor.init != NULL){
			chkDcltree1(p->s.dclor.init);
		}
		if(p->next != NULL){
			chkDcltree1(p->next);
		}
	}
	if(p->dcl_id == dcl_IDENT){
		if(p->s.ident != NULL){
			;
		}
		if(p->next != NULL){
			chkDcltree1(p->next);
		}
	}
	if(p->dcl_id == dcl_PTR){
		if(p->s.ptr != NULL){
			chkSpctree1(p->s.ptr);
		}
		if(p->next != NULL){
			chkDcltree1(p->next);
		}
	}
	if(p->dcl_id == dcl_FUNC){
		if(p->s.func != NULL){
			chkDcltree1(p->s.func);
		}
		if(p->next != NULL){
			chkDcltree1(p->next);
		}
	}
	if(p->dcl_id == dcl_ARRAY){
		if(p->s.array != NULL){
			chkExpr1(p->s.array);
		}
		if(p->next != NULL){
			chkDcltree1(p->next);
		}
	}
	if(p->dcl_id == dcl_INIT){
		if(p->s.init.inilist != NULL){
			chkDcltree1(p->s.init.inilist);
		}
		if(p->s.init.iniexpr != NULL){
			chkExpr1(p->s.init.iniexpr);
		}
		if(p->next != NULL){
			chkDcltree1(p->next);
		}
	}
	if(p->dcl_id == dcl_NONE){
		if(p->s.other != NULL){
			;
		}
		if(p->next != NULL){
			chkDcltree1(p->next);
		}
	}
	if(p->dcl_id == dcl_DDDOT){
		if(p->s.other != NULL){
			;
		}
		if(p->next != NULL){
			chkDcltree1(p->next);
		}
	}
}

void chkSpctree1(SPCTREE *a)
{
	SPCTREE *p;

	p = a;
	if(p->spc_id == spc_STRUCT || p->spc_id == spc_UNION || p->spc_id == spc_ENUM){
		if(p->s.sue.id != NULL)
			;
		if(p->s.sue.mem != NULL){
			chkDcltree1(p->s.sue.mem);
		}
		if(p->next != NULL){
			chkSpctree1(p->next);
		}
	}
	else if(p->spc_id == spc_TD_TYPE){
		if(p->s.id != NULL)
			;
		if(p->next != NULL){
			chkSpctree1(p->next);
		}
	}
	else{
		if(p->next != NULL){
			chkSpctree1(p->next);
		}
	}
}

void chkExpr1(EXPR *a)
{
	EXPR *p;

	p = a;
	if(p->opcode == op_LINER){
		if(p->u.liner != NULL){
			chkLiner1(p->u.liner);
		}
		if(p->next != NULL){
			chkExpr1(p->next);
		}
	}
	else if(p->opcode == op_SIZEOF_D || p->opcode == op_SIZEOF_I){
		if(p->u.size.dclt != NULL){
			chkDcltree1(p->u.size.dclt);
		}
		if(p->u.size.exp != NULL){
			chkExpr1(p->u.size.exp);
		}
		if(p->next != NULL){
			chkExpr1(p->next);
		}
	}
	else if(p->opcode == op_CAST){
		if(p->u.cast.dclt != NULL){
			chkDcltree1(p->u.cast.dclt);
		}
		if(p->u.cast.exp != NULL){
			chkExpr1(p->u.cast.exp);
		}
		if(p->next != NULL){
			chkExpr1(p->next);
		}
	}
	else{
		if(p->u.expr.left != NULL){
			chkExpr1(p->u.expr.left);
		}
		if(p->u.expr.right != NULL){
			chkExpr1(p->u.expr.right);
		}
		if(p->u.expr.third != NULL){
			chkExpr1(p->u.expr.third);
		}
		if(p->next != NULL){
			chkExpr1(p->next);
		}
	}

}

void chkLiner1(LINER *a)
{
	LINER *p;

	p = a;
	if(p->lineop == li_IDENT || p->lineop == li_STR || p->lineop == li_CHARA){
		if(p->liu.ident.id != NULL){
			;
		}
		if(p->next != NULL){
			chkLiner1(p->next);
		}
	}

	else if(p->lineop == li_CONST){
/*
		if(p->liu.value != NULL){
*/
			;
/*
		}
*/
		if(p->next != NULL){
			chkLiner1(p->next);
		}
	}

	else if(p->lineop == li_SAME){
		if(p->liu.exp != NULL){
			chkExpr1(p->liu.exp);
		}
		if(p->next != NULL){
			chkLiner1(p->next);
		}
	}

	else if(p->lineop == li_ARRAY || p->lineop == li_FUNC){
		if(p->liu.fa.lin != NULL){
			chkLiner1(p->liu.fa.lin);
		}
		if(p->liu.fa.exp != NULL){
			chkExpr1(p->liu.fa.exp);
		}
		if(p->next != NULL){
			chkLiner1(p->next);
		}
	}
	else if(p->lineop == li_COMMA || p->lineop == li_POMEM){
		if(p->liu.post.lin != NULL){
			chkLiner1(p->liu.post.lin);
		}
		if(p->liu.post.id != NULL){
			;
		}
		if(p->next != NULL){
			chkLiner1(p->next);
		}
	}
}

void chkStmt11(STMTREE1 *a)
{
	STMTREE1 *p;
	STMTREE2 *s2;
	p = a;
/* Warning Check Function by Kanaoka */
	Er_jisage(p);
	Er_casebreak(p);

	if(p->to_stmt2 != NULL){
		chkStmt21(p->to_stmt2);
	}
	if(p->next != NULL){
		chkStmt11(p->next);
		if(p->stmtkind != COMPOU_STK )
			 Er_blank(p);
	}
	if (Flsw == 1)
		Flsw = 0;
}

void chkStmt21(STMTREE2 *a)
{
        STMTREE2 *p;
        p = a;

	if(p->arg1 != NULL){
		chkExpr1(p->arg1);
	}
	if(p->arg2 != NULL){
		chkExpr1(p->arg2);
	}
	if(p->arg3 != NULL){
		chkExpr1(p->arg1);
	}
	if(p->nextstmt1 != NULL){
		chkStmt11(p->nextstmt1);
		if(p->nextstmt1->stmtkind == COMPOU_STK){
			fk = p->column;
			printf("STC1:%d, fk:%d, LINE:%d\n",p->code,fk,p->line);
		}
		if(p->code == COMPOU_STC){
			printf("STC2:%d, fk:%d, LINE:%d\n",p->code,fk,p->line);
			Er_blank2(p->nextstmt1,fk);
		}
		else {
			printf("STC3:%d, col:%d, LINE:%d,next1:%d\n",p->code, p->column,p->line,p->nextstmt1->stmtkind);
			Er_blank2(p->nextstmt1, p->column);
		}
		
	}
	if(p->nextstmt2 != NULL){
		chkStmt11(p->nextstmt2);
	}
	if(p->simp_exp != NULL){
		chkExpr1(p->simp_exp);
	}
	if(p->label != NULL){
	}
	if(p->dcl_list != NULL){
		chkDcltree1(p->dcl_list);
	}
}
