/*
	errchk2.c ver1.42
	1996/12/9
	by Kanayama
*/
#include "parse.h"

void chkFiltree2(FILTREE *a)
{
	FILTREE *p;

	p = a;

	if(p->fil_id == fil_FUNC){
		if(p->s.func.dcl1 != NULL){
			chkDcltree2(p->s.func.dcl1);
		}
		if(p->s.func.dcl2 != NULL){
			chkDcltree2(p->s.func.dcl2);
		}
		if(p->s.func.dcl2 != NULL){
			chkDcltree2(p->s.func.dcl2);
		}
		if(p->s.func.stmt != NULL){
			chkStmt22(p->s.func.stmt);
		}
		if(p->next != NULL){
			chkFiltree2(p->next);
		}
	}
	if(p->fil_id == fil_DECL){
		if(p->s.dcl != NULL){
			chkDcltree2(p->s.dcl);
		}
		if(p->next != NULL){
			chkFiltree2(p->next);
		}
	}
}

void chkDcltree2(DCLTREE *a)
{
	DCLTREE *p;

	p = a;

	if(p->dcl_id == dcl_DCLON || p->dcl_id == dcl_MDCLON || p->dcl_id == dcl_PDCLON){
		if(p->s.dclon.dcl != NULL){
			chkDcltree2(p->s.dclon.dcl);
		}
		if(p->s.dclon.spc != NULL){
			chkSpctree2(p->s.dclon.spc);
		}
		if(p->next != NULL){
			chkDcltree2(p->next);
		}
	}
	if(p->dcl_id == dcl_DCLOR || p->dcl_id == dcl_MDCLOR || p->dcl_id == dcl_EDCLOR){
		if(p->s.dclor.dcl != NULL){
			chkDcltree2(p->s.dclor.dcl);
		}
		if(p->s.dclor.init != NULL){
			chkDcltree2(p->s.dclor.init);
		}
		if(p->next != NULL){
			chkDcltree2(p->next);
		}
	}
	if(p->dcl_id == dcl_IDENT){
		if(p->s.ident != NULL){
			;
		}
		if(p->next != NULL){
			chkDcltree2(p->next);
		}
	}
	if(p->dcl_id == dcl_PTR){
		if(p->s.ptr != NULL){
			chkSpctree2(p->s.ptr);
		}
		if(p->next != NULL){
			chkDcltree2(p->next);
		}
	}
	if(p->dcl_id == dcl_FUNC){
		if(p->s.func != NULL){
			chkDcltree2(p->s.func);
		}
		if(p->next != NULL){
			chkDcltree2(p->next);
		}
	}
	if(p->dcl_id == dcl_ARRAY){
		if(p->s.array != NULL){
			chkExpr2(p->s.array);
		}
		if(p->next != NULL){
			chkDcltree2(p->next);
		}
	}
	if(p->dcl_id == dcl_INIT){
		if(p->s.init.inilist != NULL){
			chkDcltree2(p->s.init.inilist);
		}
		if(p->s.init.iniexpr != NULL){
			chkExpr2(p->s.init.iniexpr);
		}
		if(p->next != NULL){
			chkDcltree2(p->next);
		}
	}
	if(p->dcl_id == dcl_NONE){
		if(p->s.other != NULL){
			;
		}
		if(p->next != NULL){
			chkDcltree2(p->next);
		}
	}
	if(p->dcl_id == dcl_DDDOT){
		if(p->s.other != NULL){
			;
		}
		if(p->next != NULL){
			chkDcltree2(p->next);
		}
	}
}

void chkSpctree2(SPCTREE *a)
{
	SPCTREE *p;

	p = a;
	if(p->spc_id == spc_STRUCT || p->spc_id == spc_UNION || p->spc_id == spc_ENUM){
		if(p->s.sue.id != NULL)
			;
		if(p->s.sue.mem != NULL){
			chkDcltree2(p->s.sue.mem);
		}
		if(p->next != NULL){
			chkSpctree2(p->next);
		}
	}
	else if(p->spc_id == spc_TD_TYPE){
		if(p->s.id != NULL)
			;
		if(p->next != NULL){
			chkSpctree2(p->next);
		}
	}
	else{
		if(p->next != NULL){
			chkSpctree2(p->next);
		}
	}
}

void chkExpr2(EXPR *a)
{
	EXPR *p;

	p = a;
	if(p->opcode == op_LINER){
		if(p->u.liner != NULL){
			chkLiner2(p->u.liner);
		}
		if(p->next != NULL){
			chkExpr2(p->next);
		}
	}
	else if(p->opcode == op_SIZEOF_D || p->opcode == op_SIZEOF_I){
		if(p->u.size.dclt != NULL){
			chkDcltree2(p->u.size.dclt);
		}
		if(p->u.size.exp != NULL){
			chkExpr2(p->u.size.exp);
		}
		if(p->next != NULL){
			chkExpr2(p->next);
		}
	}
	else if(p->opcode == op_CAST){
		if(p->u.cast.dclt != NULL){
			chkDcltree2(p->u.cast.dclt);
		}
		if(p->u.cast.exp != NULL){
			chkExpr2(p->u.cast.exp);
		}
		if(p->next != NULL){
			chkExpr2(p->next);
		}
	}
	else{
		if(p->u.expr.left != NULL){
			chkExpr2(p->u.expr.left);
		}
		if(p->u.expr.right != NULL){
			chkExpr2(p->u.expr.right);
		}
		if(p->u.expr.third != NULL){
			chkExpr2(p->u.expr.third);
		}
		if(p->next != NULL){
			chkExpr2(p->next);
		}
	}

}

void chkLiner2(LINER *a)
{
	LINER *p;

	p = a;
/*	chk_str	*/
	er_Str(p);

	if(p->lineop == li_IDENT || p->lineop == li_STR || p->lineop == li_CHARA){
		if(p->liu.ident.id != NULL){
			;
		}
		if(p->next != NULL){
			chkLiner2(p->next);
		}
	}

	else if(p->lineop == li_CONST){
/*
		if(p->liu.value != NULL){
*/
			;
/*
		}
*/
		if(p->next != NULL){
			chkLiner2(p->next);
		}
	}

	else if(p->lineop == li_SAME){
		if(p->liu.exp != NULL){
			chkExpr2(p->liu.exp);
		}
		if(p->next != NULL){
			chkLiner2(p->next);
		}
	}

	else if(p->lineop == li_ARRAY || p->lineop == li_FUNC){
		if(p->liu.fa.lin != NULL){
			chkLiner2(p->liu.fa.lin);
		}
		if(p->liu.fa.exp != NULL){
			chkExpr2(p->liu.fa.exp);
		}
		if(p->next != NULL){
			chkLiner2(p->next);
		}
	}
	else if(p->lineop == li_COMMA || p->lineop == li_POMEM){
		if(p->liu.post.lin != NULL){
			chkLiner2(p->liu.post.lin);
		}
		if(p->liu.post.id != NULL){
			;
		}
		if(p->next != NULL){
			chkLiner2(p->next);
		}
	}
}

void chkStmt12(STMTREE1 *a)
{
	STMTREE1 *p;
	p = a;

	if(p->to_stmt2 != NULL){
		chkStmt22(p->to_stmt2);
	}
	if(p->next != NULL){
		chkStmt12(p->next);
	}
}

void chkStmt22(STMTREE2 *a)
{
        STMTREE2 *p;
        p = a;

	if(p->arg1 != NULL){
		chkExpr2(p->arg1);
	}
	if(p->arg2 != NULL){
		chkExpr2(p->arg2);
	}
	if(p->arg3 != NULL){
		chkExpr2(p->arg3);
	}
	if(p->nextstmt1 != NULL){
		chkStmt12(p->nextstmt1);
	}
	if(p->nextstmt2 != NULL){
		chkStmt12(p->nextstmt2);
	}
	if(p->simp_exp != NULL){
		chkExpr2(p->simp_exp);
	}
	if(p->label != NULL){
	}
	if(p->dcl_list != NULL){
		chkDcltree2(p->dcl_list);
	}
}
