/*
	main.c ver1.42
	1996/12/9
	by Kanaoka,Kanayama,Kaneko
*/
#include	"parse.h"

void main(int argc, char *argv[])
{
	extern	FILE	*yyin;
	char 		cec[256] = "cc -E ";

	if(argc > 1){
		strcpy(FileName,argv[1]);
		strcat(cec,argv[1]);

		if((yyin = popen(cec,"r")) == NULL){
			printf("Error:%s:No such file or directry.\n",FileName);
			exit(1);
		}
		printf("Filename:%s\n",FileName);
	}
	init_parse();

	yyparse();

	treechk();
	if(argc > 1){
		pclose(yyin);
	}

}

yyerror(s)
char *s;

{
	fprintf(stderr,"%s\n",s);
}

void	init_parse(void)
{
	Linetimes = 1;
	RealLinetimes = 1;
	Columntimes = 0;
	FileFlag  = 0;
	Symtblptr = NULL;
	td_init();
}

void	chkprint(char *s1,char *s2)
{
	printf("	%s:%s\n",s1,s2);
}

void	line_print(char *fn,int line)
{
	printf("File:%s\tLine:%d\n",fn,line);
}

void	treechk(void)
{
	chkFiltree(startptr);  
        chkFiltree1(startptr);
/*        chkFiltree2(startptr);
	chkFiltree3(startptr);  */
}

int	pri_line_change(char *s)
{
	int	line;
	char	tfname[256];
	char	filename[256];
	int 	i;

	sscanf(s,"%d %s ",&line,tfname);

	i = 1;
	while(tfname[i] != '\"'){
		filename[i-1] = tfname[i];
		i++;
	}
	filename[i-1] = '\0';


	strcpy(FileName,filename);
	return(line-1);
}

/* by Kaneko */
void	td_init(void)
{
	Td_Type_Num = 0;
}

void	td_save(char *s)
{
	char	c;
	int	len, i;

	len = strlen(s);
	for(i=0;i<len;i++){
		c = s[i];
		if(!((c>='a'&&c<='z')||(c>='A'&&c<='Z')||(c>='0'&&c<='9')||(c=='_'))){
			Td_Type[Td_Type_Num][i]='\0';
			break;
		}
		Td_Type[Td_Type_Num][i] = c;
	}
	Td_Type_Num++;
}

void	td_chkprint(void)
{
	int	i;

	for(i=0;i<Td_Type_Num;i++){
		printf("td(%d):%s\n",i,Td_Type[i]);
	}
}

int	td_chk(char *s)
{
	int	i;

	for(i=0;i<Td_Type_Num;i++){
		if(strcmp(Td_Type[i],s)==0)
			return(1);
	}
	return(0);
}

char *saveIdent(char *s)
{
	int len;
	char *p;

	len = strlen(s) + 1;
	p = (char *)malloc(len);
	if(p == NULL)
		printf("Overflow\n");

	return strcpy(p,s);
}

