/*
	maketree.c ver1.42
	1996/12/9
	by Kaneko
*/
#include	"parse.h"

/*
	File Tree make  by Kaneko
*/
FILTREE *mkFiltree(FILID a, FILTREE *b, SPCTREE *c,
			 	DCLTREE *d, DCLTREE *e, STMTREE2 *f,int line,int column)
{
	FILTREE *p;

	p = (FILTREE *)malloc(sizeof(FILTREE));
	if(p == NULL)
		printf("Overflow\n");

	p->fil_id = a;
	p->next	  = b;
	if	(a == fil_DECL)
		p->s.dcl = d;
	else if	(a == fil_FUNC){
		p->s.func.spc = c;
		p->s.func.dcl1 = d;
		p->s.func.dcl2 = e;
		p->s.func.stmt = f;
	}
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);
	return p;
}

FILTREE *conectFil(FILTREE *a, FILTREE *b)
{
	FILTREE *p;
	for(p = a ; p->next != NULL ; p=p->next);
	p->next = b;

	return a;
}

/*
	Declaration Tree make  by Kaneko
*/
DCLTREE *mkDcltree(DCLID a, DCLTREE *b, void *c,int line,int column)
{
	DCLTREE *p;

	p = (DCLTREE *)malloc(sizeof(DCLTREE));
	if(p == NULL)
		printf("Overflow\n");

	p->dcl_id = a;
	p->next	  = b;
	if	(a == dcl_IDENT)	p->s.ident = c;
	else if	(a == dcl_ARRAY)	p->s.array = c;
	else if (a == dcl_FUNC)		p->s.func  = c;
	else if (a == dcl_PTR)		p->s.ptr   = c;
	else				p->s.other = c;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

DCLTREE *mkDcldclon(DCLID a, DCLTREE *b, DCLTREE *c, SPCTREE *d,int line,int column)
{
	DCLTREE *p;

	p = (DCLTREE *)malloc(sizeof(DCLTREE));
	if(p == NULL)
		printf("Overflow\n");

	p->dcl_id = a;
	p->next	  = b;

	p->s.dclon.dcl = c;
	p->s.dclon.spc = d;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

DCLTREE *mkDcldclor(DCLID a, DCLTREE *b, DCLTREE *c, DCLTREE *d,int line,int column)
{
	DCLTREE *p;

	p = (DCLTREE *)malloc(sizeof(DCLTREE));
	if(p == NULL)
		printf("Overflow\n");

	p->dcl_id = a;
	p->next	  = b;
	p->s.dclor.dcl  = c;
	p->s.dclor.init = d;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

DCLTREE *mkInit(DCLID a, DCLTREE *b, DCLTREE *c, EXPR *d,int line,int column)
{
	DCLTREE *p;

	p = (DCLTREE *)malloc(sizeof(DCLTREE));
	if(p == NULL)
		printf("Overflow\n");

	p->dcl_id = a;
	p->next	  = b;
	p->s.init.inilist = c;
	p->s.init.iniexpr = d;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

DCLTREE *conectDcl(DCLTREE *a, DCLTREE *b)
{
	DCLTREE *p;
	for(p = a ; p->next != NULL ; p=p->next);
	p->next = b;
	return a;
}

SPCTREE *mkSpctree(SPCID a, SPCTREE *b,int line,int column)
{
	SPCTREE *p;

	p = (SPCTREE *)malloc(sizeof(SPCTREE));
	if(p == NULL)
		printf("Overflow\n");

	p->spc_id = a;
	p->next   = b;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

SPCTREE *mkSpcsue(SPCID a, SPCTREE *b, char *c, DCLTREE *d,int line,int column)
{
	SPCTREE *p;

	p = (SPCTREE *)malloc(sizeof(SPCTREE));
	if(p == NULL)
		printf("Overflow\n");

	p->spc_id    = a;
	p->next      = b;
	p->s.sue.id  = c;
	p->s.sue.mem = d;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

SPCTREE *mkSpctdtype(SPCID a, SPCTREE *b, char *c,int line,int column)
{
	SPCTREE *p;

	p = (SPCTREE *)malloc(sizeof(SPCTREE));
	if(p == NULL)
		printf("Overflow\n");

	p->spc_id = a;
	p->next   = b;
	p->s.id   = c;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

SPCTREE *conectSpc(SPCTREE *a, SPCTREE *b)
{
	SPCTREE *p;
	for(p = a ; p->next != NULL ; p=p->next);
	p->next = b;
	return a;
}

/*
	Expression Tree make  by Kanayama
*/
EXPR *makenode1(OPCODE a, EXPR *b, EXPR *left,int line,int column)
{
	EXPR *p;

	p = (EXPR *)malloc(sizeof(EXPR));
	if(p == NULL)
		printf("heap overflow\n");

	p->opcode = a;
	p->next   = NULL;
	p->u.expr.left = left;
	p->u.expr.right = NULL;
	p->u.expr.third = NULL;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

EXPR *makenode2(OPCODE a, EXPR *b, EXPR *left, EXPR *right,int line,int column)
{
	EXPR *p;

	p = (EXPR *)malloc(sizeof(EXPR));
	if(p == NULL)
		printf("heap overflow\n");

	p->opcode  = a;
	p->next    = NULL;
	p->u.expr.left = left;
	p->u.expr.right = right;
	p->u.expr.third = NULL;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

EXPR *makenode3(OPCODE a, EXPR *b, EXPR *left, EXPR *right,EXPR *third,int line,int column)
{
	EXPR *p;

	p = (EXPR *)malloc(sizeof(EXPR));
	if(p == NULL)
		printf("heap overflow\n");

	p->opcode  = a;
	p->next    = NULL;
	p->u.expr.left  = left;
	p->u.expr.right = right;
	p->u.expr.third = third;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

EXPR *makenodeS(OPCODE a, EXPR *b, void *c,int line,int column)
{
        EXPR *p;

        p = (EXPR *)malloc(sizeof(EXPR));
        if(p == NULL)
                printf("heap overflow\n");

        p->opcode 	= a;
        p->next   	= NULL;
	if	(a == op_SIZEOF_D)	p->u.size.dclt = c;
        else if (a == op_SIZEOF_I)	p->u.size.exp  = c;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

        return p;
}

EXPR *makecast(OPCODE a, EXPR *b, DCLTREE *c, EXPR *d ,int line,int column)
{
        EXPR *p;

        p = (EXPR *)malloc(sizeof(EXPR));
        if(p == NULL)
                printf("heap overflow\n");

        p->opcode       = a;
        p->next         = NULL;
	p->u.cast.dclt  = c;
	p->u.cast.exp  = d;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

        return p;
}

EXPR *makeline(OPCODE a, EXPR *b, LINER *c ,int line,int column)
{
        EXPR *p;

        p = (EXPR *)malloc(sizeof(EXPR));
        if(p == NULL)
                printf("heap overflow\n");

        p->opcode       = a;
        p->next         = NULL;
        p->u.liner 	= c;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

        return p;
}


LINER *makelineid(LINEOP a, LINER *b, char *c ,int line,int column)
{
	LINER *p;

	p = (LINER *)malloc(sizeof(LINER));
	if(p == NULL)
		printf("heap overflow\n");

	p->lineop	= a;
	p->next		= b;
	p->liu.ident.id	= c;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

LINER *makeconst(LINEOP a, LINER *b, double c, char d, int line, int column)
{
        LINER *p;

        p = (LINER *)malloc(sizeof(LINER));
        if(p == NULL)
                printf("heap overflow\n");

        p->lineop       = a;
        p->next         = b;
        p->liu.value.va	= c;
        p->liu.value.sp = d;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

        return p;
}

LINER *makelinexp(LINEOP a, LINER *b, EXPR *c ,int line,int column)
{
        LINER *p;

        p = (LINER *)malloc(sizeof(LINER));
        if(p == NULL)
                printf("heap overflow\n");

        p->lineop       = a;
        p->next         = b;
        p->liu.exp      = c;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

        return p;
}

LINER *makefa(LINEOP a, LINER *b, LINER *c, EXPR *d ,int line,int column)
{
        LINER *p;

        p = (LINER *)malloc(sizeof(LINER));
        if(p == NULL)
                printf("heap overflow\n");

        p->lineop       = a;
        p->next         = b;
        p->liu.fa.lin   = c;
	p->liu.fa.exp	= d;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

        return p;
}

LINER *makepost(LINEOP a, LINER *b, LINER *c, char *d ,int line,int column)
{
        LINER *p;

        p = (LINER *)malloc(sizeof(LINER));
        if(p == NULL)
                printf("heap overflow\n");

        p->lineop       = a;
        p->next         = b;
        p->liu.post.lin   = c;
        p->liu.post.id	= d;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

        return p;
}

EXPR *conectExp(EXPR *a, EXPR *b)
{
        EXPR *p;

        for(p = a ; p->next != NULL ; p=p->next);
        p->next = b;
        return a;
}

/*
	Statement Tree make  by Kanaoka
*/
STMTREE1 *makestmtree1 (STMTKIND a, STMTREE1 *b,STMTREE2 *c,int line,int column)
{
	STMTREE1 *p;

	p = (STMTREE1 *)malloc(sizeof(STMTREE1));
	if(p == NULL)
		printf("Overflow\n");

	p->stmtkind = a;
	p->next = b;
	p->to_stmt2 =c;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}


STMTREE2 *makestmtree2 (STMTCODE a, EXPR *b, EXPR *c, EXPR *d, STMTREE1 *e, STMTREE1 *f,
				EXPR *g, char *h, DCLTREE *i,int line,int column)
{
	STMTREE2 *p;

	p = (STMTREE2 *)malloc(sizeof(STMTREE2));
	if(p == NULL)
		printf(" Overflow\n");

	p->code      = a;
	p->arg1      = b;
	p->arg2      = c;
	p->arg3      = d;
	p->nextstmt1 = e;
	p->nextstmt2 = f;
	p->simp_exp  = g;
	p->label     = h;
	p->dcl_list  = i;
	p->line = line;
	p->column = column;
	strcpy(p->filename,FileName);

	return p;
}

STMTREE1 *conectSTM(STMTREE1 *a,STMTREE1 *b)
{
        STMTREE1 *p;
        for(p = a ; p->next != NULL ; p=p->next);
        p->next = b;
        return a;
}

