/*
	mksymtbl.c ver1.42
	1996/12/9
	by Kaneko
*/
#include "parse.h"

char mkSpcsym(SPCTREE *a)
{
	SPCTREE *p;
	int	sflag,flag;

	p = a;
	flag = 1;
	sflag = 0;

	if(p == NULL){
		flag = 0;
		return('0');
	}

	while(flag){
		switch(p->spc_id){
			case(spc_VOID):		sflag = sflag | 0x001;	break;
			case(spc_CHAR):		sflag = sflag | 0x002;	break;
			case(spc_SHORT):	sflag = sflag | 0x004;	break;
			case(spc_INT):		sflag = sflag | 0x008;	break;
			case(spc_LONG):		sflag = sflag | 0x010;	break;
			case(spc_FLOAT):	sflag = sflag | 0x020;	break;
			case(spc_DOUBLE):	sflag = sflag | 0x040;	break;
			case(spc_SIGNED):	sflag = sflag | 0x080;	break;
			case(spc_UNSIGNED):	sflag = sflag | 0x100;	break;
			case(spc_STRUCT):	sflag = sflag | 0x200;	break;
			case(spc_UNION):	sflag = sflag | 0x400;	break;
			case(spc_ENUM):		sflag = sflag | 0x800;	break;
			case(spc_TD_TYPE):	sflag = 0x1000;		break;
		}
		if(p->next == NULL)
			flag = 0;
		else
			p = p->next;
	}

	switch(sflag){
		case(0x001):	return('V'); break;	/* void */
		case(0x002):	return('C'); break;	/* char */
		case(0x082):	return('A'); break;	/* signed char */
		case(0x102):	return('c'); break;	/* unsigned char */
		case(0x004):				/* short */
		case(0x084):				/* signed short */
		case(0x00c):				/* short int */
		case(0x08c):	return('S'); break;	/* signed short int */
		case(0x104):				/* unsigned short */
		case(0x10c):	return('s'); break;	/* unsigned short int */
		case(0x000):				/* No */
		case(0x008):				/* int */
		case(0x088):	return('I'); break;	/* signed int */
		case(0x100):				/* unsigned */
		case(0x108):	return('i'); break;	/* unsigned int */
		case(0x010):				/* long */
		case(0x090):				/* signed long */
		case(0x018):				/* long int */
		case(0x098):	return('L'); break;	/* signed long int */
		case(0x110):				/* unsigned long */
		case(0x118):	return('l'); break;	/* unsigned long int */
		case(0x020):	return('F'); break;	/* float */
		case(0x040):	return('D'); break;	/* double */
		case(0x050):	return('d'); break;	/* long double */
		case(0x200):	return('R'); break;	/* struct */
		case(0x400):	return('U'); break;	/* union */
		case(0x800):	return('E'); break;	/* enum */
		case(0x1000):	return('T'); break;	/* typedef type */
		default:	return('0'); break;	/* No */
	}
}

void mkSymtbldn(DCLTREE *a)
{
	DCLTREE *p,*dn_dl;
	SPCTREE	*dn_sp;

	p = a;
	if(p->s.dclon.dcl != NULL){
		if(p->s.dclon.dcl->dcl_id == dcl_DCLOR){
			dn_sp = p->s.dclon.spc;
			dn_dl = p->s.dclon.dcl;
			mkSymtbldr(dn_sp,dn_dl);
		}
	}
}

void mkSymtbldr(SPCTREE *a,DCLTREE *b)
{
	DCLTREE *dr_dl,*ddt1;
	SPCTREE	*dn_sp,*dst1;
	SYMTBL	*st,*st1;

	dn_sp = a;
	dr_dl = b;

	st = (SYMTBL *)malloc(sizeof(SYMTBL));

	if(mkSpcsym(dn_sp) == 'T'){
		dst1 = dn_sp;
		while(dst1->spc_id != spc_TD_TYPE)
			dst1 = dst1->next;
		st1 = Symtblptr;
		while(strcmp(dst1->s.id,st1->decl->s.ident) != 0)
			st1 = st1->back;
		ddt1 = dr_dl->s.dclor.dcl;
		while(ddt1->next != NULL)
			ddt1 = ddt1->next;
		ddt1->next = st1->decl->next;
		st->decl = dr_dl->s.dclor.dcl;
		st->spec = st1->spec;
	}
	else if(mkSpcsym(dn_sp) == 'R'){
		dst1 = dn_sp;
		while(dst1->spc_id != spc_STRUCT)
			dst1 = dst1->next;
		st->sptr = dst1;
		st->decl = dr_dl->s.dclor.dcl;
		st->spec = mkSpcsym(dn_sp);
	}
	else if(mkSpcsym(dn_sp) == 'U'){
		dst1 = dn_sp;
		while(dst1->spc_id != spc_UNION)
			dst1 = dst1->next;
		st->sptr = dst1;
		st->decl = dr_dl->s.dclor.dcl;
		st->spec = mkSpcsym(dn_sp);
	}
	else if(mkSpcsym(dn_sp) == 'E'){
		dst1 = dn_sp;
		while(dst1->spc_id != spc_ENUM)
			dst1 = dst1->next;
		st->sptr = dst1;
		st->decl = dr_dl->s.dclor.dcl;
		st->spec = mkSpcsym(dn_sp);
	}
	else{
		st->decl = dr_dl->s.dclor.dcl;
		st->spec = mkSpcsym(dn_sp);
	}
	st->back = Symtblptr;
	Symtblptr = st;

	if(dr_dl->next != NULL){
		mkSymtbldr(dn_sp,dr_dl->next);
	}
}

void mkSymtbldp(DCLTREE *a)
{
	DCLTREE *p,*dp_dl;
	SPCTREE *dp_sp;
	SYMTBL	*st;

	p = a;
	dp_dl = p->s.dclon.dcl;
	dp_sp = p->s.dclon.spc;

	if(dp_sp != NULL && dp_dl != NULL){
		if(dp_dl->dcl_id == dcl_IDENT){
			st = (SYMTBL *)malloc(sizeof(SYMTBL));

			st->decl = dp_dl;
			st->spec = mkSpcsym(dp_sp);
			st->back = Symtblptr;

			Symtblptr = st;
		}
	}
}

void mkSymtblfn(SPCTREE *a,DCLTREE *b)
{
	DCLTREE *fn_dl;
	SPCTREE	*fn_sp;
	SYMTBL	*st;

	fn_sp = a;
	fn_dl = b;

	st = (SYMTBL *)malloc(sizeof(SYMTBL));

	st->decl = fn_dl;
	st->spec = mkSpcsym(fn_sp);
	st->back = Symtblptr;

	Symtblptr = st;

}

void toSymtbl(LINER *a,SYMTBL *b)
{
	LINER	*p;
	SYMTBL	*st;

	p = a;
	st = b;

	if(strcmp(p->liu.ident.id,st->decl->s.ident) == 0){
		p->liu.ident.st = st;
	}
	else{
		p->liu.ident.st = NULL;
		if(st->back != NULL){
			toSymtbl(p,st->back);
		}
	}
}

void prSymtbl(SYMTBL *a)
{
	SYMTBL	*p;
	DCLTREE	*dt1;

	p = a;

	if(p->decl != NULL){
		printf("SymTbl:%s:%c\n",p->decl->s.ident,p->spec);
		dt1 = p->decl;
		while(dt1->next != NULL){
			printf("\t");
			dclpr(dt1->dcl_id);
			printf("\n");
			dt1 = dt1->next;
		}
		printf("\t");
		dclpr(dt1->dcl_id);
		printf("\n");

	}
	else{
		printf("SymTbl:(NULL):%c\n",p->spec);
	}
	if(p->back != NULL){
		prSymtbl(p->back);
	}
}

