/*
	parse.h ver1.42
	1996/12/9
	by Kanaoka,Knayama,Kaneko
*/
#include	<stdio.h>
#include	<math.h>
#include	<string.h>
#include	<stdlib.h>

#define		MAX_TD_TYPE	256
#define		MAX_TD_NUM	256
#define		MAXSTRING	256
#define		ON		1
#define		OFF		0

/*
	For All Files
*/
char 		FileName[MAXSTRING];
char		RealFileName[MAXSTRING];
int		Linetimes;
int		Columntimes;
int		RealLinetimes;
int		FileFlag;
struct filtree	*startptr;
char		Strings[MAXSTRING];
int		ColumnFlag;
/*
	For Typedef  by Kaneko
*/
char		Td_Type[MAX_TD_TYPE][MAX_TD_NUM];
char		Td_Ident[MAX_TD_TYPE];
int		Td_Type_Num;
int		Td_Flag;
int		Td_stnest;
int		Td_fnnest;

/*
	For maketree.c  by Kaneko,Kanaoka,Kanayama
*/

typedef enum{
	fil_FUNC = 1,	/* function */
	fil_DECL	/* declaration */
}FILID;

typedef struct filtree{
	FILID		fil_id;
	struct filtree	*next;
	union{
		struct dcltree *dcl;
		struct{
			struct spctree	*spc;
			struct dcltree	*dcl1;
			struct dcltree	*dcl2;
			struct stmtree2	*stmt;
		}func;
	}s;
	int		line;
	int		column;
	char		filename[MAXSTRING];
}FILTREE;

typedef	enum{
	dcl_DCLON = 1,	/* declaration */
	dcl_DCLOR,	/* declarator */
	dcl_MDCLON,	/* member declor */
	dcl_MDCLOR,	/* member declor */
	dcl_EDCLOR,	/* enum declor */
	dcl_PDCLON,	/* param */
	dcl_IDENT,	/* identifer */
	dcl_NONE,	/* empty */
	dcl_PTR,	/* pointer */
	dcl_FUNC,	/* function */
	dcl_ARRAY,	/* array */
	dcl_DDDOT,	/* DDDOT */
	dcl_INIT	/* initalizer */
}DCLID;

typedef struct	dcltree{
	DCLID			dcl_id;
	struct dcltree		*next;
	union {
		struct{
			struct dcltree	*dcl;
			struct spctree	*spc;
		}dclon; 		/* declaration */
		struct{
			struct dcltree	*dcl;
			struct dcltree	*init;
		}dclor;			/* declarator */
		char		*ident;	/* identifier */
		struct spctree	*ptr;	/* pointer */
		struct dcltree	*func;	/* func */
		struct expr	*array;	/* array */
		struct{
			struct dcltree	*inilist;
			struct expr	*iniexpr;
		}init;			/* initalizer */
		char		*other;	/* empty DDDOT */
	}s;
	int		line;
	int		column;
	char		filename[MAXSTRING];
}DCLTREE;

typedef enum{
	spc_AUTO = 1,
	spc_EXTERN,
	spc_REGISTER,
	spc_STATIC,
	spc_TYPEDEF,

	spc_CHAR,
	spc_INT,
	spc_SHORT,
	spc_LONG,
	spc_UNSIGNED,
	spc_SIGNED,
	spc_FLOAT,
	spc_DOUBLE,
	spc_VOID,

	spc_STRUCT,
	spc_UNION,
	spc_ENUM,

	spc_TD_TYPE,

	spc_CONST,
	spc_VOLATILE,

	spc_POINTER
}SPCID;

typedef struct spctree{
	SPCID		spc_id;
	struct spctree	*next;
	union {
		struct {
			char		*id;
			struct dcltree	*mem;
		}sue;			/* Struct Union Enum */
		char	*id;		/* Typedef Tyep */
	}s;
	int		line;
	int		column;
	char		filename[MAXSTRING];
}SPCTREE;

typedef enum {
	op_LINER = 1,
	op_ADR,op_INDIR,
	op_ASSIGN,	/* = */
	op_ASSIGN_ADD,	/* += */
	op_ASSIGN_SUB,	/* -= */
	op_ASSIGN_MUL,	/* *= */
	op_ASSIGN_DIV,	/* /= */
	op_ASSIGN_MOD,	/* %= */
	op_ASSIGN_SHR,	/* >>= */
	op_ASSIGN_SHL,	/* <<= */
	op_ASSIGN_AND,	/* &= */
	op_ASSIGN_XOR,	/* ^= */
	op_ASSIGN_OR,	/* |= */
	op_ADD,op_SUB,
	op_BNOT,op_LNOT,
	op_PREINC,op_PREDEC,op_POSTINC,op_POSTDEC,
	op_MOD,op_DIV,op_MUL,
	op_SHR,op_SHL,
	op_GT,op_GE,op_LT,op_LE,
	op_EQ,op_NEQ,
	op_AND,op_XOR,op_OR,
	op_LAND,op_LOR,
	op_COND,
	op_PLUS,
	op_MINUS,
	op_SIZEOF_D,
	op_SIZEOF_I,
	op_CAST
}OPCODE;

typedef struct expr{
	OPCODE 		opcode;
	struct expr	*next;
	union{
		struct liner	*liner;
		struct{
			struct dcltree  *dclt;
                        struct expr     *exp;
		}cast;
		union{
			struct dcltree	*dclt;
			struct expr	*exp;
		}size;
		struct{
			struct expr	*left;
			struct expr	*right;
			struct expr	*third;
		}expr;
	}u;
	int		line;
	int		column;
	char		filename[MAXSTRING];
}EXPR;

typedef enum {
	li_IDENT = 1,
	li_CONST,
	li_STR,
	li_CHARA,
	li_SAME,
	li_ARRAY,
	li_FUNC,
	li_COMMA,
	li_POMEM
}LINEOP;

typedef struct liner{
	LINEOP		lineop;
	struct liner	*next;
	union{
		struct{
			char		*id;
			struct symtbl	*st;
		} ident;
		struct{
			double		va;
			char		sp;
		} value;
		EXPR	*exp;
		struct{
			struct liner	*lin;
			struct expr	*exp;
		} fa;
		struct{
			struct liner	*lin;
			char		*id;
		} post;
	}liu;
	int		line;
	int		column;
	char		filename[MAXSTRING];
}LINER;

typedef enum{
	EMPTY_STK = 1,
	SIMPLE_STK,
	COMPOU_STK,
	CONDIT_STK,
	ITERAT_STK,
	SELECT_STK,
	JUMP_STK,
	LABELL_STK,
	NULL_STK,
	SELECT1_STK
}STMTKIND;

typedef enum{
	SIMPLE_STC = 1,
	COMPOU_STC,
	IF_STC,
	IF_ELSE_STC,
	WHILE_STC,
	FOR_STC,
	DO_WHILE_STC,
	SWITCH_STC,
	CASE_STC,
	DEFAULT_STC,
	RETURN_STC,
	GOTO_STC,
	BREAK_STC,
	CONTINUE_STC,
	LABBEL_STC,
	STMT_NULL_STC
}STMTCODE;

typedef struct stmtree1{
	STMTKIND	stmtkind;
	struct stmtree1	*next;
	struct stmtree2	*to_stmt2;
	int		line;
	int		column;
	char		filename[MAXSTRING];
}STMTREE1;

typedef struct stmtree2{
	STMTCODE	code;
	struct expr	*arg1;
	struct expr	*arg2;   /* FOR for */
	struct expr	*arg3;    /* FOR for */
	struct stmtree1	*nextstmt1;
	struct stmtree1	*nextstmt2; /*FOR else */
	struct expr	*simp_exp;
	char		*label;
	struct dcltree  *dcl_list;
	int		line;
	int		column;
	char		filename[MAXSTRING];
}STMTREE2;


typedef struct symtbl{
	struct dcltree	*decl;
	char		spec;
	struct symtbl	*back;
	struct spctree	*sptr;
}SYMTBL;

SYMTBL	*Symtblptr;

typedef struct const_data{
        double  va;
        char    sp;
}CONST_DATA;


/*                   */
/*   Function Decl   */
/*                   */

/*
	main.c
*/
void	init_parse();
void	chkprint();
void	line_print();
void	treechk();
int	pri_line_change();
void	td_save();
void	td_init();
void	td_chkprint();
int	td_chk();
char	*saveIdent();

/*
	treechk.c
*/
void	filpr();
void	chkFiltree();
void	dclpr();
void	chkDcltree();
void	spcpr();
void	chkSpctree();
void	exppr();
void	chkExpr();
void	linerpr();
void	chkLiner();
void	stkpr();
void	chkStmt1();
void	stcpr();
void	chkStmt2();

/*
	maketree.c
*/
FILTREE		*mkFiltree();
FILTREE		*conectFil();
DCLTREE		*mkDcltree();
DCLTREE		*mkDcldclon();
DCLTREE		*mkDcldclor();
DCLTREE		*mkInit();
DCLTREE		*conectDcl();
SPCTREE		*mkSpctree();
SPCTREE		*mkSpcsue();
SPCTREE		*mkSpctdtype();
SPCTREE		*conectSpc();
EXPR		*makenode1();
EXPR		*makenode2();
EXPR		*makenode3();
EXPR		*makenodeS();
EXPR		*makecast();
EXPR		*makeline();
EXPR		*conectExp();
LINER		*makelineid();
LINER		*makeconst(LINEOP,LINER *,double,char,int,int);
LINER		*makelinexp();
LINER		*makefa();
LINER		*makepost();
STMTREE1	*makestmtree1();
STMTREE2	*makestmtree2();
STMTREE1	*conectSTM();

/*
	mksymtbl.c
*/
void mkSymtbldn();
void mkSymtbldr();
void mkSymtbldp();
void mkSymtblfn();
void toSymtbl();
char mkSpcsym();
void prSymtbl();

/*
        errchk1.c
*/
void    chkFiltree1();
void    chkDcltree1();
void    chkSpctree1();
void    chkExpr1();
void    chkLiner1();
void    chkStmt11();
void    chkStmt21();

int Flsw,Flcs,Flbk,Fldf,fk;
/*
        error1.c
*/

void Er_jisage();
void Er_casebreak();
void Er_blank();
void Er_blank2();

/*
        errchk2.c
*/
void    chkFiltree2();
void    chkDcltree2();
void    chkSpctree2();
void    chkExpr2();
void    chkLiner2();
void    chkStmt12();
void    chkStmt22();

/*
	errchk3.c
*/
void	chkFiltree3();
void	chkDcltree3();
void	chkSpctree3();
void	chkExpr3();
void	chkLiner3();
void	chkStmt13();
void	chkStmt23();

/*
	error3.c
*/
void	er_eq();

