/*
	parse.l ver1.42
	1996/12/9
	by Kanaoka,Kanayama,Kaneko
*/
%{
#include	"parse.h"
#include        "y.tab.h"

%}
%e		1500
%p		3000

SPACE		[ ]
TAB		[\t]
NEWLINE		[\n]
BDIGIT		[01]
ODIGIT		[0-7]
NDIGIT		[1-9]
DIGIT		[0-9]
HDIGIT		[0-9a-fA-F]
EXP		([Ee][+-]?{DIGIT}+)
FS		[fF]
LS		[lL]
US		[uU]
IS		({US}{LS}|{LS}{US})
IDENT		([_a-zA-Z][_a-zA-Z0-9]*)

DDDOT		"..."
POMEM		"->"
INC		"++"
DEC		"--"
UNOP		("~"|"!")
MULOP		("/"|"%")
ADDOP		("+"|"-")
SHIFTOP_R	">>"
SHIFTOP_L	"<<"
COMPOP_GT	">"
COMPOP_LT	"<"
COMPOP_GE	">="
COMPOP_LE	"<="
EQOP		"=="
NEQOP		"!="
LOGAND		"&&"
LOGOR		"||"
ASSIGNOP	"="
ASSIGNOP_ADD	"+="
ASSIGNOP_SUB	"-="
ASSIGNOP_MOD	"%="
ASSIGNOP_AND	"&="
ASSIGNOP_MUL	"*="
ASSIGNOP_DIV	"/="
ASSIGNOP_SHL	"<<="
ASSIGNOP_SHR	">>="
ASSIGNOP_XOR	"^="
ASSIGNOP_OR	"|="

ESCAPECODE	[\\][n|t|b|r|f|\\|'|\"|v|a|"0"]
COMMENTST	"/*"
COMMENTEND	"*/"
PASSIDENT	("__inline"|"__attribute__((const))"|"__attribute__((noreturn))")

%start	COMMENT STRING CHARACT PRIPRO

%%

	int	intval;
	char	charval[256];

{PASSIDENT}		;


<INITIAL,COMMENT,STRING,CHARACT>{NEWLINE}	{
			Linetimes++;
			RealLinetimes++;
			Columntimes = 0;
			ColumnFlag = 1;
			}
<INITIAL>"/*"		{
			BEGIN COMMENT;
			}
<INITIAL>\"		{
			BEGIN STRING;
			Strings[0] = '\0';
			}
<INITIAL>'		{
			BEGIN CHARACT;
			Strings[0] = '\0';
			}
<INITIAL>"#"		{
			BEGIN PRIPRO;
			}
<COMMENT>"*/"		{
			BEGIN INITIAL;
			}
<COMMENT>(.)		;
<STRING>\"		{
			BEGIN INITIAL;
			yylval.symbol = (char *)saveIdent(Strings);
			ColumnFlag = 0; return(STRINGS);
			}
<CHARACT>'		{
			BEGIN INITIAL;
			yylval.symbol = (char *)saveIdent(Strings);
			ColumnFlag = 0; return(CHARACTER);
			}
<CHARACT,STRING>(.)	{
			strcat(Strings,yytext);
			}
<PRIPRO>({DIGIT}+)({SPACE}*)(\")(.*)(\")	{
			Linetimes = pri_line_change(yytext);
			}
<PRIPRO>({DIGIT}+)({SPACE}*)(\")(.*)(\")({SPACE}*)({DIGIT}+)	{
			Linetimes = pri_line_change(yytext);
			}
<PRIPRO>({DIGIT}+)({SPACE}*)(\")([^\n\t\" ])(\")({SPACE}*)({DIGIT}+)({SPACE}*)({DIGIT}+)	{
			Linetimes = pri_line_change(yytext);
			}
<PRIPRO>(.)		{
			/*
			printf("This program can't use PRIPROCESSOR.\n\tusage:>cc -E [filename] | ./parse.\n");
			exit(0);
			*/
			}
<PRIPRO>{NEWLINE}	{
			BEGIN INITIAL;
			Linetimes++;
			RealLinetimes++;
			Columntimes = 0;
			ColumnFlag = 1;
			}

<INITIAL>{SPACE}	{
			if(ColumnFlag == 1)
				Columntimes = Columntimes + 1;
			}
<INITIAL>{TAB}		{
			if(ColumnFlag == 1)
				Columntimes = Columntimes + 8;
			}

<INITIAL>(auto)		{ ColumnFlag = 0; return(AUTO); }
<INITIAL>(int)		{ ColumnFlag = 0; return(INT); }
<INITIAL>(char)		{ ColumnFlag = 0; return(CHAR); }
<INITIAL>(long)		{ ColumnFlag = 0; return(LONG); }
<INITIAL>(double)	{ ColumnFlag = 0; return(DOUBLE); }
<INITIAL>(float)	{ ColumnFlag = 0; return(FLOAT); }
<INITIAL>(short)	{ ColumnFlag = 0; return(SHORT); }
<INITIAL>(void)		{ ColumnFlag = 0; return(VOID); }

<INITIAL>(enum)		{ ColumnFlag = 0; return(ENUM); }
<INITIAL>(struct)	{ ColumnFlag = 0; return(STRUCT); }
<INITIAL>(union)	{ ColumnFlag = 0; return(UNION); }

<INITIAL>(signed)	{ ColumnFlag = 0; return(SIGNED); }
<INITIAL>(unsigned)	{ ColumnFlag = 0; return(UNSIGNED); }
<INITIAL>(typedef)	{ ColumnFlag = 0; return(TYPEDEF); }
<INITIAL>(static)	{ ColumnFlag = 0; return(STATIC); }
<INITIAL>(extern)	{ ColumnFlag = 0; return(EXTERN); }
<INITIAL>(register)	{ ColumnFlag = 0; return(REGISTER); }
<INITIAL>(const)	{ ColumnFlag = 0; return(CONST); }
<INITIAL>(volatile)	{ ColumnFlag = 0; return(VOLATILE); }

<INITIAL>(if)		{ ColumnFlag = 0; return(IF); }
<INITIAL>(else)		{ ColumnFlag = 0; return(ELSE); }
<INITIAL>(while)	{ ColumnFlag = 0; return(WHILE); }
<INITIAL>(do)		{ ColumnFlag = 0; return(DO); }
<INITIAL>(switch)	{ ColumnFlag = 0; return(SWITCH); }
<INITIAL>(case)		{ ColumnFlag = 0; return(CASE); }
<INITIAL>(for)		{ ColumnFlag = 0; return(FOR); }
<INITIAL>(break)	{ ColumnFlag = 0; return(BREAK); }
<INITIAL>(continue)	{ ColumnFlag = 0; return(CONTINUE); }
<INITIAL>(default)	{ ColumnFlag = 0; return(DEFAULT); }
<INITIAL>(goto)		{ ColumnFlag = 0; return(GOTO); }
<INITIAL>(return)	{ ColumnFlag = 0; return(RETURN); }
<INITIAL>(sizeof)	{ ColumnFlag = 0; return(SIZEOF); }

<INITIAL>{DDDOT}	{ ColumnFlag = 0; return(DDDOT); }

<INITIAL>{IDENT}	{
			yylval.symbol = (char *)saveIdent(yytext);
			if(td_chk(yytext)==1){
				ColumnFlag = 0; return(TYPEDEF_TYPE);
			}
			else{
				ColumnFlag = 0; return(IDENTIFIER);
			}
			}

<INITIAL>{INC}		{ ColumnFlag = 0; return(inc); }
<INITIAL>{DEC}		{ ColumnFlag = 0; return(dec); }
<INITIAL>{UNOP}		{ ColumnFlag = 0; return(unop); }
<INITIAL>{MULOP}	{ ColumnFlag = 0; return(mulop);}
<INITIAL>{ADDOP}	{ ColumnFlag = 0; return(addop); }
<INITIAL>{SHIFTOP_R}	{ ColumnFlag = 0; return(shiftop_L); }
<INITIAL>{SHIFTOP_L}	{ ColumnFlag = 0; return(shiftop_R); }
<INITIAL>{COMPOP_GT}	{ ColumnFlag = 0; return(compop_GT); }
<INITIAL>{COMPOP_LT}	{ ColumnFlag = 0; return(compop_LT); }
<INITIAL>{COMPOP_GE}	{ ColumnFlag = 0; return(compop_GE); }
<INITIAL>{COMPOP_LE}	{ ColumnFlag = 0; return(compop_LE); }
<INITIAL>{EQOP}		{ ColumnFlag = 0; return(eqop); }
<INITIAL>{NEQOP}	{ ColumnFlag = 0; return(neqop); }
<INITIAL>{LOGAND}	{ ColumnFlag = 0; return(logand); }
<INITIAL>{LOGOR}	{ ColumnFlag = 0; return(logor); }
<INITIAL>{ASSIGNOP}	{ ColumnFlag = 0; return(assignop); }
<INITIAL>{ASSIGNOP_ADD}	{ ColumnFlag = 0; return(assignop_ADD); }
<INITIAL>{ASSIGNOP_SUB}	{ ColumnFlag = 0; return(assignop_SUB); }
<INITIAL>{ASSIGNOP_MOD}	{ ColumnFlag = 0; return(assignop_MOD); }
<INITIAL>{ASSIGNOP_AND}	{ ColumnFlag = 0; return(assignop_AND); }
<INITIAL>{ASSIGNOP_MUL}	{ ColumnFlag = 0; return(assignop_MUL); }
<INITIAL>{ASSIGNOP_DIV}	{ ColumnFlag = 0; return(assignop_DIV); }
<INITIAL>{ASSIGNOP_SHL}	{ ColumnFlag = 0; return(assignop_SHL); }
<INITIAL>{ASSIGNOP_SHR}	{ ColumnFlag = 0; return(assignop_SHR); }
<INITIAL>{ASSIGNOP_XOR}	{ ColumnFlag = 0; return(assignop_XOR); }
<INITIAL>{ASSIGNOP_OR}	{ ColumnFlag = 0; return(assignop_OR); }

<INITIAL>{POMEM}	{ ColumnFlag = 0; return(pomem); }


<INITIAL>{DIGIT}+"."{DIGIT}*{EXP}?{FS}	|
<INITIAL>{DIGIT}*"."{DIGIT}+{EXP}?{FS}	|
<INITIAL>{DIGIT}+{EXP}{FS}	{
			yylval.value.va=atof(yytext);
			yylval.value.sp='F';
			ColumnFlag = 0; return(CONSTANT);}
<INITIAL>{DIGIT}+"."{DIGIT}*{EXP}?{LS}	|
<INITIAL>{DIGIT}*"."{DIGIT}+{EXP}?{LS}	|
<INITIAL>{DIGIT}+{EXP}{LS}	{
			yylval.value.va=atof(yytext);
			yylval.value.sp='d';
			ColumnFlag = 0; return(CONSTANT);}
<INITIAL>{DIGIT}+"."{DIGIT}*{EXP}?	|
<INITIAL>{DIGIT}*"."{DIGIT}+{EXP}?	|
<INITIAL>{DIGIT}+{EXP}	{
			yylval.value.va=atof(yytext);
			yylval.value.sp='D';
			ColumnFlag = 0; return(CONSTANT);}
<INITIAL>0{IS}		{
			yylval.value.va=(double)0;
			yylval.value.sp='l';
			ColumnFlag = 0; return(CONSTANT);}
<INITIAL>{NDIGIT}{DIGIT}*{IS}	{
			yylval.value.va=(double)atol(yytext);
			yylval.value.sp='l';
			ColumnFlag = 0; return(CONSTANT);}
<INITIAL>0{ODIGIT}*{IS}	{
			sscanf(yytext+2,"%o",&intval);
			yylval.value.va=(double)intval;
			yylval.value.sp='l';
			ColumnFlag = 0; return(CONSTANT);}
<INITIAL>0[xX]{HDIGIT}+{IS}	{
			sscanf(yytext+2,"%x",&intval);
			yylval.value.va=(double)intval;
			yylval.value.sp='l';
			ColumnFlag = 0; return(CONSTANT);}
<INITIAL>0{LS}		{
			yylval.value.va=(double)0;
			yylval.value.sp='L';
			ColumnFlag = 0; return(CONSTANT);}
<INITIAL>{NDIGIT}{DIGIT}*{LS}	{
			yylval.value.va=(double)atol(yytext);
			yylval.value.sp='L';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>0{ODIGIT}*{LS}	{
			sscanf(yytext+2,"%o",&intval);
			yylval.value.va=(double)intval;
			yylval.value.sp='L';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>0[xX]{HDIGIT}+{LS}	{
			sscanf(yytext+2,"%x",&intval);
			yylval.value.va=(double)intval;
			yylval.value.sp='L';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>0{US}		{
			yylval.value.va=(double)0;
			yylval.value.sp='i';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>{NDIGIT}{DIGIT}*{US}	{
			yylval.value.va=(double)atol(yytext);
			yylval.value.sp='i';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>0{ODIGIT}*{US}	{
			sscanf(yytext+2,"%o",&intval);
			yylval.value.va=(double)intval;
			yylval.value.sp='i';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>0[xX]{HDIGIT}+{US}	{
			sscanf(yytext+2,"%x",&intval);
			yylval.value.va=(double)intval;
			yylval.value.sp='i';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>0		{
			yylval.value.va=(double)0;
			yylval.value.sp='I';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>{NDIGIT}{DIGIT}*	{
			yylval.value.va=(double)atol(yytext);
			yylval.value.sp='I';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>0{ODIGIT}*	{
			sscanf(yytext+2,"%o",&intval);
			yylval.value.va=(double)intval;
			yylval.value.sp='I';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>0[xX]{HDIGIT}+		{
			sscanf(yytext+2,"%x",&intval);
			yylval.value.va=(double)intval;
			yylval.value.sp='I';
			ColumnFlag = 0; return(CONSTANT);
			}
<INITIAL>(.)		{
			ColumnFlag = 0; return(*yytext);
			}
%%
