/*
	treechk.c ver1.42
	1996/12/9
	by Kaneko
*/
#include "parse.h"

void filpr(FILID a)
{
	if(a == fil_FUNC)	printf("fil_FUNC\t");
	if(a == fil_DECL)	printf("fil_DECL\t");
}
void chkFiltree(FILTREE *a)
{
	FILTREE *p;
	SYMTBL	*st;

	p = a;
	if(p->fil_id == fil_FUNC){
/** Make Symtbl **/
		mkSymtblfn(p->s.func.spc, p->s.func.dcl1);
/** *********** **/
/** Save Symtblptr **/
		st = Symtblptr;
/** ************** **/
		filpr(p->fil_id);
		if(p->s.func.spc != NULL){
			printf("=>SPC:to dcl\n");
			chkSpctree(p->s.func.spc);
		}
		else	printf("=>SPC:NULL\n");
		filpr(p->fil_id);
		if(p->s.func.dcl1 != NULL){
			printf("=>DCL1:to dcl\n");
			chkDcltree(p->s.func.dcl1);
		}
		else	printf("=>DCL1:NULL\n");
		filpr(p->fil_id);
		if(p->s.func.dcl2 != NULL){
			printf("=>DCL2:to dcl\n");
			chkDcltree(p->s.func.dcl2);
		}
		else	printf("=>DCL2:NULL\n");
		filpr(p->fil_id);
		if(p->s.func.stmt != NULL){
			printf("=>STMT:to stmt\n");
			chkStmt2(p->s.func.stmt);
		}
		else	printf("=>STMT:NULL\n");
/** Load Symtblptr **/
		Symtblptr = st;
/** ************** **/
		filpr(p->fil_id);
		if(p->next != NULL){
			printf("=>NEXT:to fil\n");
			chkFiltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	if(p->fil_id == fil_DECL){
		filpr(p->fil_id);
		if(p->s.dcl != NULL){
			printf("=>DCL:to dcl\n");
			chkDcltree(p->s.dcl);
		}
		else	printf("=>DCL:NULL\n");

		filpr(p->fil_id);
		if(p->next != NULL){
			printf("=>NEXT:to fil\n");
			chkFiltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}

}

void dclpr(DCLID a)
{
	if(a == dcl_DCLON)	printf("dcl_DCLON\t");
	if(a == dcl_DCLOR)	printf("dcl_DCLOR\t");
	if(a == dcl_MDCLON)	printf("dcl_MDCLON\t");
	if(a == dcl_MDCLOR)	printf("dcl_MDCLOR\t");
	if(a == dcl_EDCLOR)	printf("dcl_EDCLOR\t");
	if(a == dcl_PDCLON)	printf("dcl_PDCLON\t");
	if(a == dcl_IDENT)	printf("dcl_IDENT\t");
	if(a == dcl_NONE)	printf("dcl_NONE\t");
	if(a == dcl_PTR)	printf("dcl_PTR\t\t");
	if(a == dcl_FUNC)	printf("dcl_FUNC\t");
	if(a == dcl_ARRAY)	printf("dcl_ARRAY\t");
	if(a == dcl_DDDOT)	printf("dcl_DDDOT\t");
	if(a == dcl_INIT)	printf("dcl_INIT\t");
}
void chkDcltree(DCLTREE *a)
{
	DCLTREE *p;

	p = a;
	if(p->dcl_id == dcl_DCLON || p->dcl_id == dcl_MDCLON || p->dcl_id == dcl_PDCLON){
/** Make Symtbl **/
		if(p->dcl_id == dcl_DCLON)
			mkSymtbldn(p);
		if(p->dcl_id == dcl_PDCLON)
			mkSymtbldp(p);
/** *********** **/
		dclpr(p->dcl_id);
		if(p->s.dclon.dcl != NULL){
			printf("=>DCL:to dcl\n");
			chkDcltree(p->s.dclon.dcl);
		}
		else	printf("=>DCL:NULL\n");

		dclpr(p->dcl_id);
		if(p->s.dclon.spc != NULL){
			printf("=>SPC:to spc\n");
			chkSpctree(p->s.dclon.spc);
		}
		else	printf("=>SPC:NULL\n");

		dclpr(p->dcl_id);
		if(p->next != NULL){
			printf("=>NEXT:to dcl\n");
			chkDcltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	if(p->dcl_id == dcl_DCLOR || p->dcl_id == dcl_MDCLOR || p->dcl_id == dcl_EDCLOR){
		dclpr(p->dcl_id);
		if(p->s.dclor.dcl != NULL){
			printf("=>DCL:to dcl\n");
			chkDcltree(p->s.dclor.dcl);
		}
		else	printf("=>DCL:NULL\n");

		dclpr(p->dcl_id);
		if(p->s.dclor.init != NULL){
			printf("=>INIT:to dcl\n");
			chkDcltree(p->s.dclor.init);
		}
		else	printf("=>INIT:NULL\n");

		dclpr(p->dcl_id);
		if(p->next != NULL){
			printf("=>NEXT:to dcl\n");
			chkDcltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	if(p->dcl_id == dcl_IDENT){
		dclpr(p->dcl_id);
		if(p->s.ident != NULL){
			printf("=>IDENT:%s\n",p->s.ident);
		}
		else	printf("=>IDENT:NULL\n");
		dclpr(p->dcl_id);
		if(p->next != NULL){
			printf("=>NEXT:to dcl\n");
			chkDcltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	if(p->dcl_id == dcl_PTR){
		dclpr(p->dcl_id);
		if(p->s.ptr != NULL){
			printf("=>PTR:to spc\n");
			chkSpctree(p->s.ptr);
		}
		else	printf("=>PTR:NULL\n");
		dclpr(p->dcl_id);
		if(p->next != NULL){
			printf("=>NEXT:to dcl\n");
			chkDcltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	if(p->dcl_id == dcl_FUNC){
		dclpr(p->dcl_id);
		if(p->s.func != NULL){
			printf("=>FUNC:to dcl\n");
			chkDcltree(p->s.func);
		}
		else	printf("=>FUNC:NULL\n");
		dclpr(p->dcl_id);
		if(p->next != NULL){
			printf("=>NEXT:to dcl\n");
			chkDcltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	if(p->dcl_id == dcl_ARRAY){
		dclpr(p->dcl_id);
		if(p->s.array != NULL){
			printf("=>ARRAY:to exp\n");
			chkExpr(p->s.array);
		}
		else	printf("=>ARRAY:NULL\n");
		dclpr(p->dcl_id);
		if(p->next != NULL){
			printf("=>NEXT:to dcl\n");
			chkDcltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	if(p->dcl_id == dcl_INIT){
		dclpr(p->dcl_id);
		if(p->s.init.inilist != NULL){
			printf("=>INITLIST:to dcl\n");
			chkDcltree(p->s.init.inilist);
		}
		else	printf("=>INITLIST:NULL\n");
		dclpr(p->dcl_id);
		if(p->s.init.iniexpr != NULL){
			printf("=>INIEXPR:to exp\n");
			chkExpr(p->s.init.iniexpr);
		}
		else	printf("=>INITEXPR:NULL\n");
		dclpr(p->dcl_id);
		if(p->next != NULL){
			printf("=>NEXT:to dcl\n");
			chkDcltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	if(p->dcl_id == dcl_NONE){
		dclpr(p->dcl_id);
		if(p->s.other != NULL){
			printf("=>OTHER:NULL\n");
		}
		else	printf("=>OTHER:NULL\n");
		dclpr(p->dcl_id);
		if(p->next != NULL){
			printf("=>NEXT:to dcl\n");
			chkDcltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	if(p->dcl_id == dcl_DDDOT){
		dclpr(p->dcl_id);
		if(p->s.other != NULL){
			printf("=>OTHER:NULL\n");
		}
		else	printf("=>OTHER:NULL\n");
		dclpr(p->dcl_id);
		if(p->next != NULL){
			printf("=>NEXT:to dcl\n");
			chkDcltree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
}

void spcpr(SPCID a)
{
	if(a == spc_AUTO)	printf("spc_AUTO\t");
	if(a == spc_EXTERN)	printf("spc_EXTERN\t");
	if(a == spc_REGISTER)	printf("spc_REGISTER\t");
	if(a == spc_STATIC)	printf("spc_STATIC\t");
	if(a == spc_TYPEDEF)	printf("spc_TYPEDEF\t");
	if(a == spc_CHAR)	printf("spc_CHAR\t");
	if(a == spc_INT)	printf("spc_INT\t\t");
	if(a == spc_SHORT)	printf("spc_SHORT\t");
	if(a == spc_LONG)	printf("spc_LONG\t");
	if(a == spc_UNSIGNED)	printf("spc_UNSIGNED\t");
	if(a == spc_SIGNED)	printf("spc_SIGNED\t");
	if(a == spc_FLOAT)	printf("spc_FLOAT\t");
	if(a == spc_DOUBLE)	printf("spc_DOUBLE\t");
	if(a == spc_VOID)	printf("spc_VOID\t");
	if(a == spc_STRUCT)	printf("spc_STRUCT\t");
	if(a == spc_UNION)	printf("spc_UNION\t");
	if(a == spc_ENUM)	printf("spc_ENUM\t");
	if(a == spc_TD_TYPE)	printf("spc_TD_TYPE\t");
	if(a == spc_CONST)	printf("spc_CONST\t");
	if(a == spc_VOLATILE)	printf("spc_VOLATILE\t");
	if(a == spc_POINTER)	printf("spc_POINTER\t");
}

void chkSpctree(SPCTREE *a)
{
	SPCTREE *p;

	p = a;
	if(p->spc_id == spc_STRUCT || p->spc_id == spc_UNION || p->spc_id == spc_ENUM){
		spcpr(p->spc_id);
		if(p->s.sue.id != NULL)
			printf("=>ID:%s\n",p->s.sue.id);
		else	printf("=>ID:NULL\n");

		spcpr(p->spc_id);
		if(p->s.sue.mem != NULL){
			printf("=>MEM:to dcl\n");
			chkDcltree(p->s.sue.mem);
		}
		else	printf("=>MEM:NULL\n");

		spcpr(p->spc_id);
		if(p->next != NULL){
			printf("=>NEXT:to spc\n");
			chkSpctree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	else if(p->spc_id == spc_TD_TYPE){
		spcpr(p->spc_id);
		if(p->s.id != NULL)
			printf("=>ID:%s\n",p->s.id);
		else	printf("=>ID:NULL\n");

		spcpr(p->spc_id);
		if(p->next != NULL){
			printf("=>NEXT:to spc\n");
			chkSpctree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
	else{
		spcpr(p->spc_id);
		if(p->next != NULL){
			printf("=>NEXT:to spc\n");
			chkSpctree(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
}

void exppr(OPCODE a)
{
	if(a == op_LINER)	printf("op_LINER\t");
	if(a == op_ADR)		printf("op_ADR\t\t");
	if(a == op_INDIR)	printf("op_INDIR\t");
	if(a == op_ASSIGN)	printf("op_ASSIGN\t");
	if(a == op_ASSIGN_ADD)	printf("op_ASSIGN_ADD\t");
	if(a == op_ASSIGN_SUB)	printf("op_ASSIGN_SUB\t");
	if(a == op_ASSIGN_MUL)	printf("op_ASSIGN_MUL\t");
	if(a == op_ASSIGN_DIV)	printf("op_ASSIGN_DIV\t");
	if(a == op_ASSIGN_MOD)	printf("op_ASSIGN_MOD\t");
	if(a == op_ASSIGN_SHR)	printf("op_ASSIGN_SHR\t");
	if(a == op_ASSIGN_SHL)	printf("op_ASSIGN_SHL\t");
	if(a == op_ASSIGN_AND)	printf("op_ASSIGN_AND\t");
	if(a == op_ASSIGN_XOR)	printf("op_ASSIGN_XOR\t");
	if(a == op_ASSIGN_OR)	printf("op_ASSIGN_OR\t");
	if(a == op_ADD)		printf("op_ADD\t\t");
	if(a == op_SUB)		printf("op_SUB\t\t");
	if(a == op_BNOT)	printf("op_BNOT\t\t");
	if(a == op_LNOT)	printf("op_LNOT\t\t");
	if(a == op_PREINC)	printf("op_PREINC\t");
	if(a == op_PREDEC)	printf("op_PREDEC\t");
	if(a == op_POSTINC)	printf("op_POSTINC\t");
	if(a == op_POSTDEC)	printf("op_POSTDEC\t");
	if(a == op_MOD)		printf("op_MOD\t\t");
	if(a == op_DIV)		printf("op_DIV\t\t");
	if(a == op_MUL)		printf("op_MUL\t\t");
	if(a == op_SHR)		printf("op_SHR\t\t");
	if(a == op_SHL)		printf("op_SHL\t\t");
	if(a == op_GT)		printf("op_GT\t\t");
	if(a == op_GE)		printf("op_GE\t\t");
	if(a == op_LT)		printf("op_LT\t\t");
	if(a == op_LE)		printf("op_LE\t\t");
	if(a == op_EQ)		printf("op_EQ\t\t");
	if(a == op_NEQ)		printf("op_NEQ\t\t");
	if(a == op_AND)		printf("op_AND\t\t");
	if(a == op_XOR)		printf("op_XOR\t\t");
	if(a == op_OR)		printf("op_OR\t\t");
	if(a == op_LAND)	printf("op_LAND\t\t");
	if(a == op_LOR)		printf("op_LOR\t\t");
	if(a == op_COND)	printf("op_COND\t\t");
	if(a == op_PLUS)	printf("op_PLUS\t\t");
	if(a == op_MINUS)	printf("op_MINUS\t");
	if(a == op_SIZEOF_D)	printf("op_SIZEOF_D\t");
	if(a == op_SIZEOF_I)	printf("op_SIZEOF_I\t");
	if(a == op_CAST)	printf("op_CAST\t\t");
}

void chkExpr(EXPR *a)
{
	EXPR *p;

	p = a;
	if(p->opcode == op_LINER){
		exppr(p->opcode);
		if(p->u.liner != NULL){
			printf("=>LINER:to liner\n");
			chkLiner(p->u.liner);
		}
		else	printf("=>LINER:NULL\n");

		exppr(p->opcode);
		if(p->next != NULL){
			printf("=>NEXT:to exp\n");
			chkExpr(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}

	else if(p->opcode == op_SIZEOF_D || p->opcode == op_SIZEOF_I){
		exppr(p->opcode);
		if(p->u.size.dclt != NULL){
			printf("=>DCLT:to dcl\n");
			chkDcltree(p->u.size.dclt);
		}
		else	printf("=>DCLT:NULL\n");

		exppr(p->opcode);
		if(p->u.size.exp != NULL){
			printf("=>EXP:to exp\n");
			chkExpr(p->u.size.exp);
		}
		else	printf("=>DCLT:NULL\n");

		exppr(p->opcode);
		if(p->next != NULL){
			printf("=>NEXT:to exp\n");
			chkExpr(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}

	else if(p->opcode == op_CAST){
		exppr(p->opcode);
		if(p->u.cast.dclt != NULL){
			printf("=>DCLT:to dcl\n");
			chkDcltree(p->u.cast.dclt);
		}
		else	printf("=>DCLT:NULL\n");

		exppr(p->opcode);
		if(p->u.cast.exp != NULL){
			printf("=>EXP:to exp\n");
			chkExpr(p->u.cast.exp);
		}
		else	printf("=>DCLT:NULL\n");

		exppr(p->opcode);
		if(p->next != NULL){
			printf("=>NEXT:to exp\n");
			chkExpr(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}

	else{
		exppr(p->opcode);
		if(p->u.expr.left != NULL){
			printf("=>LEFT:to exp\n");
			chkExpr(p->u.expr.left);
		}
		else	printf("=>LEFT:NULL\n");

		exppr(p->opcode);
		if(p->u.expr.right != NULL){
			printf("=>RIGHT:to exp\n");
			chkExpr(p->u.expr.right);
		}
		else	printf("=>RIGHT:NULL\n");

		exppr(p->opcode);
		if(p->u.expr.third != NULL){
			printf("=>THIRD:to exp\n");
			chkExpr(p->u.expr.third);
		}
		else	printf("=>THIRD:NULL\n");

		exppr(p->opcode);
		if(p->next != NULL){
			printf("=>NEXT:to exp\n");
			chkExpr(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}

}

void linerpr(LINEOP a)
{
	if(a == li_IDENT)	printf("li_IDENT\t");
	if(a == li_CONST)	printf("li_CONST\t");
	if(a == li_STR)		printf("li_STR\t\t");
	if(a == li_CHARA)	printf("li_CHARA\t");
	if(a == li_SAME)	printf("li_SAME\t\t");
	if(a == li_ARRAY)	printf("li_ARRAY\t");
	if(a == li_FUNC)	printf("li_FUNC\t\t");
	if(a == li_COMMA)	printf("li_COMMA\t");
	if(a == li_POMEM)	printf("li_POMEM\t");
}

void chkLiner(LINER *a)
{
	LINER *p;

	p = a;
	if(p->lineop == li_IDENT || p->lineop == li_STR || p->lineop == li_CHARA){
/** To Symtbl **/
		if(p->lineop == li_IDENT){
			toSymtbl(p,Symtblptr);
		}
/** ********* **/
		linerpr(p->lineop);
		if(p->liu.ident.id != NULL){
			printf("=>ID:%s\n",p->liu.ident.id);
			if(p->lineop == li_IDENT){
				if(p->liu.ident.st != NULL)
					printf("\tSpec:%c\n",p->liu.ident.st->spec);
			}
		}
		else	printf("=>ID:NULL\n");

		linerpr(p->lineop);
		if(p->next != NULL){
			printf("=>NEXT:to lin\n");
			chkLiner(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}

	else if(p->lineop == li_CONST){
		linerpr(p->lineop);
		printf("=>VALUE:%f(%c)\n",p->liu.value.va,p->liu.value.sp);
		linerpr(p->lineop);
		if(p->next != NULL){
			printf("=>NEXT:to lin\n");
			chkLiner(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}

	else if(p->lineop == li_SAME){
		linerpr(p->lineop);
		if(p->liu.exp != NULL){
			printf("=>EXP:to exp\n");
			chkExpr(p->liu.exp);
		}
		else	printf("=>EXP:NULL\n");

		linerpr(p->lineop);
		if(p->next != NULL){
			printf("=>NEXT:to lin\n");
			chkLiner(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}

	else if(p->lineop == li_ARRAY || p->lineop == li_FUNC){
		linerpr(p->lineop);
		if(p->liu.fa.lin != NULL){
			printf("=>LIN:to lin\n");
			chkLiner(p->liu.fa.lin);
		}
		else	printf("=>LIN:NULL\n");

		linerpr(p->lineop);
		if(p->liu.fa.exp != NULL){
			printf("=>EXP:to exp\n");
			chkExpr(p->liu.fa.exp);
		}
		else	printf("=>EXP:NULL\n");

		linerpr(p->lineop);
		if(p->next != NULL){
			printf("=>NEXT:to lin\n");
			chkLiner(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}

	else if(p->lineop == li_COMMA || p->lineop == li_POMEM){
		linerpr(p->lineop);
		if(p->liu.post.lin != NULL){
			printf("=>LIN:to lin\n");
			chkLiner(p->liu.post.lin);
		}
		else	printf("=>LIN:NULL\n");

		linerpr(p->lineop);
		if(p->liu.post.id != NULL){
			printf("=>ID:%s\n",p->liu.post.id);
		}
		else	printf("=>ID:NULL\n");

		linerpr(p->lineop);
		if(p->next != NULL){
			printf("=>NEXT:to lin\n");
			chkLiner(p->next);
		}
		else	printf("=>NEXT:NULL\n");
	}
}

void stkpr(STMTKIND a)
{
	if(a == EMPTY_STK)	printf("EMPTY_STK\t");
	if(a == SIMPLE_STK)	printf("SIMPLE_STK\t");
	if(a == COMPOU_STK)	printf("COMPOU_STK\t");
	if(a == CONDIT_STK)	printf("CONDIT_STK\t");
	if(a == ITERAT_STK)	printf("ITERAT_STK\t");
	if(a == SELECT_STK)	printf("SELECT_STK\t");
	if(a == JUMP_STK)	printf("JUMP_STK\t");
	if(a == LABELL_STK)	printf("LABELL_STK\t");
	if(a == NULL_STK)	printf("NULL_STK\t");
	if(a == SELECT1_STK)	printf("SELECT1_STK\t");
}
void chkStmt1(STMTREE1 *a)
{
	STMTREE1 *p;
	SYMTBL	 *st;
	p = a;

/** Save Symtblptr **/
	if(p->stmtkind == COMPOU_STK){
		st = Symtblptr;
	}
/** ************** **/
	stkpr(p->stmtkind);
	if(p->to_stmt2 != NULL){
		printf("=>TO_STMT2:to stmt2\n");
		chkStmt2(p->to_stmt2);
	}
	else	printf("=>TO_STMT2:NULL\n");
/** Load Symtblptr **/
	if(p->stmtkind == COMPOU_STK){
		Symtblptr = st;
	}
/** ************** **/
	stkpr(p->stmtkind);
	if(p->next != NULL){
		printf("=>NEXT:to stmt1\n");
		chkStmt1(p->next);
	}
	else	printf("=>NEXT:NULL\n");
}

void stcpr(STMTCODE a)
{
	if(a == SIMPLE_STC)	printf("SIMPLE_STC\t");
	if(a == COMPOU_STC)	printf("COMPOU_STC\t");
	if(a == IF_STC)		printf("IF_STC\t\t");
	if(a == IF_ELSE_STC)	printf("IF_ELSE_STC\t");
	if(a == WHILE_STC)	printf("WHILE_STC\t");
	if(a == FOR_STC)	printf("FOR_STC\t\t");
	if(a == DO_WHILE_STC)	printf("DO_WHILE_STC\t");
	if(a == SWITCH_STC)	printf("SWITCH_STC\t");
	if(a == CASE_STC)	printf("CASE_STC\t");
	if(a == DEFAULT_STC)	printf("DEFAULT_STC\t");
	if(a == RETURN_STC)	printf("RETURN_STC\t");
	if(a == GOTO_STC)	printf("GOTO_STC\t");
	if(a == BREAK_STC)	printf("BREAK_STC\t");
	if(a == CONTINUE_STC)	printf("CONTINUE_STC\t");
	if(a == LABBEL_STC)	printf("LABBEL_STC\t");
	if(a == STMT_NULL_STC)	printf("STMT_NULL_STC\t");
}

void chkStmt2(STMTREE2 *a)
{
        STMTREE2 *p;
        p = a;

	stcpr(p->code);
	if(p->dcl_list != NULL){
		printf("=>DCL_LIST:to dcl\n");
		chkDcltree(p->dcl_list);
	}
	else	printf("=>DCL_LIST:NULL\n");

	stcpr(p->code);
	if(p->arg1 != NULL){
		printf("=>ARG1:to exp\n");
		chkExpr(p->arg1);
	}
	else	printf("=>ARG1:NULL\n");

	stcpr(p->code);
	if(p->arg2 != NULL){
		printf("=>ARG2:to exp\n");
		chkExpr(p->arg2);
	}
	else	printf("=>ARG2:NULL\n");

	stcpr(p->code);
	if(p->arg3 != NULL){
		printf("=>ARG3:to exp\n");
		chkExpr(p->arg3);
	}
	else	printf("=>ARG3:NULL\n");

	stcpr(p->code);
	if(p->nextstmt1 != NULL){
		printf("=>NEXTSTMT1:to stm1\n");
		chkStmt1(p->nextstmt1);
	}
	else	printf("=>NEXTSTMT1:NULL\n");

	stcpr(p->code);
	if(p->nextstmt2 != NULL){
		printf("=>NEXTSTMT2:to stm1\n");
		chkStmt1(p->nextstmt2);
	}
	else	printf("=>NEXTSTMT2:NULL\n");

	stcpr(p->code);
	if(p->simp_exp != NULL){
		printf("=>SIMP_EXPR:to exp\n");
		chkExpr(p->simp_exp);
	}
	else	printf("=>SIMP_EXPR:NULL\n");

	stcpr(p->code);
	if(p->label != NULL){
		printf("=>LABEL:%s\n",p->label);
	}
	else	printf("=>LABEL:NULL\n");
}
